﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Globalization;
using System.Threading;
using BSF_Benchmark.Properties;

namespace BSF_Benchmark
{
    public partial class MainForm : Form
    {
        private Stopwatch _stopwatch = new Stopwatch();

        public MainForm()
        {
            InitializeComponent();
            nudLoops.Value = Settings.Default.Iterations;
        }

        protected override void OnClosing(CancelEventArgs e)
        {
            Settings.Default.Iterations = nudLoops.Value;
            Settings.Default.Save();
            base.OnClosing(e);
        }

        private void btnBenchmark_Click(object sender, EventArgs e)
        {
            long time1 = 0;
            long time2 = 0;

            // alternate
            _stopwatch.Start();
            BenchmarkCode1();
            _stopwatch.Stop();
            time1 = _stopwatch.ElapsedTicks;
            _stopwatch.Reset();

            _stopwatch.Start();
            BenchmarkCode2();
            _stopwatch.Stop();
            time2 = _stopwatch.ElapsedTicks;
            _stopwatch.Reset();

            _stopwatch.Start();
            BenchmarkCode1();
            _stopwatch.Stop();
            time1 += _stopwatch.ElapsedTicks;
            _stopwatch.Reset();

            _stopwatch.Start();
            BenchmarkCode2();
            _stopwatch.Stop();
            time2 += _stopwatch.ElapsedTicks;
            _stopwatch.Reset();

            _stopwatch.Start();
            BenchmarkCode1();
            _stopwatch.Stop();
            time1 += _stopwatch.ElapsedTicks;
            _stopwatch.Reset();

            _stopwatch.Start();
            BenchmarkCode2();
            _stopwatch.Stop();
            time2 += _stopwatch.ElapsedTicks;
            _stopwatch.Reset();

            _stopwatch.Start();
            BenchmarkCode1();
            _stopwatch.Stop();
            time1 += _stopwatch.ElapsedTicks;
            _stopwatch.Reset();

            _stopwatch.Start();
            BenchmarkCode2();
            _stopwatch.Stop();
            time2 += _stopwatch.ElapsedTicks;
            _stopwatch.Reset();


            _stopwatch.Start();
            BenchmarkCode1();
            _stopwatch.Stop();
            time1 += _stopwatch.ElapsedTicks;
            _stopwatch.Reset();

            _stopwatch.Start();
            BenchmarkCode2();
            _stopwatch.Stop();
            time2 += _stopwatch.ElapsedTicks;
            _stopwatch.Reset();

            _stopwatch.Start();
            BenchmarkCode1();
            _stopwatch.Stop();
            time1 += _stopwatch.ElapsedTicks;
            _stopwatch.Reset();

            _stopwatch.Start();
            BenchmarkCode2();
            _stopwatch.Stop();
            time2 += _stopwatch.ElapsedTicks;
            _stopwatch.Reset();

            lblTime1.Text = time1.ToString();
            lblTime2.Text = time2.ToString();

            double percent = Math.Round(((double)time1 / time2), 3);
            lblRatio.Text = lblRatio.Tag + percent.ToString();

            double totalTime = ((double)time1 + time2) / Stopwatch.Frequency;
            totalTime = Math.Round(totalTime, 2);
            lblTotalTime.Text = lblTotalTime.Tag + totalTime.ToString();
        }

        private void BenchmarkCode1()
        {
            List<Vertex> vertexes = new List<Vertex>();

            for (int i = 0; i < nudLoops.Value; i++)
            {
                vertexes.Add(new Vertex(i, i, i));
            }

            Vertex[] VS = vertexes.ToArray();

            for (int i = 0; i < VS.Length; i++)
            {
                VS[i].X = i + 1;
                VS[i].Y = i + 1;
                VS[i].Z = i + 1;
            }
        }

        private void BenchmarkCode2()
        {
            List<VertexStruct> vertexes = new List<VertexStruct>();

            for (int i = 0; i < nudLoops.Value; i++)
            {
                vertexes.Add(new VertexStruct(i, i, i));
            }

            VertexStruct[] VS = vertexes.ToArray();

            for (int i = 0; i < VS.Length; i++)
            {
                VS[i].X = i + 1;
                VS[i].Y = i + 1;
                VS[i].Z = i + 1;
            }
        }
    }
}
